/****************************************************************
** File name:   ESP32_ADC.h
** Descrizione: Libreria per rilevare una grandezza a valle dell'ADC
**    
** Versione:    1.0          
** E-mail: us.newsoft@gmail.com
** Autore: Salvatore Urciuolo
** Data:   07/06/2018 
****************************************************************/


#ifndef ESP32_ADC_H
#define ESP32_ADC_H

#include <Arduino.h>
#include <driver\adc.h>
#include <esp_adc_cal.h>

#define versw  "ESP_ADC: 1.0 del 07/06/2018"
#define RET_OK                     0
#define RET_NOK                   -1
#define ERR_CONFIG_ADC_RESOLUTION -2
#define ERR_CONFIG_CHANNEL        -3

#define DEFAULT_VREF   1100
#define NUM_SAMPLES      64
#define NUM_SAMPLES_MAX 128

class ESP32_ADC
{	
	adc1_channel_t                m_channel;        // id del canale [0..7]	
	adc_bits_width_t              m_adc_Resolution; // lunghezza in bits 
	esp_adc_cal_characteristics_t m_characteristics;
	int                           m_numSamples;
					    	
public:
     ESP32_ADC(void);
    ~ESP32_ADC(void);
    int   init(int adc_width_res,int channel,int atten,int numSamples);
	float readVoltage();
	int   getNumSamples(void);
	char * getVersion(void);
};

#endif
